#define _GNU_SOURCE
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>

static void barf(const char *tag)
{
    perror(tag);
    exit(EXIT_FAILURE);
}

int main(void) {
    uid_t ru, eu, su;
    gid_t rg, eg, sg;

    if (getresuid(&ru, &eu, &su)) barf("getresuid");
    printf("ruid=%ld euid=%ld suid=%ld\n", (long)ru, (long)eu, (long)su);
    if (getresgid(&rg, &eg, &sg)) barf("getresgid");
    printf("rgid=%ld egid=%ld sgid=%ld\n", (long)rg, (long)eg, (long)sg);
    fflush(stdout);
    exit(ferror(stdout) ? EXIT_FAILURE : EXIT_SUCCESS);
}
